import * as Helpers from "./helpers";
import * as Config from "../config";
import { FilterOverlay } from "./overlays/filteroverlay";
import { NodeInfoOverlay } from "./overlays/nodeinfo";
import Graph from "./graph";
import screenfull from "screenfull";

function loadComponents() {
    filterOverlay.create();
    infoOverlay.create();
    // filterOverlay.filterChangedCallback = (cls) =>
    //     infoOverlay.bottomMenu.toggleTabVisibility(cls);
    createFullScreenButton();
}

function createFullScreenButton() {
    const sceneNode = Helpers.getCanvasDivNode();
    const overlayNode = Helpers.createDiv("fullscreen-button", sceneNode, {
        innerHTML: "<p>&#10530;</p>",
        title: "Vollbild",
    });
    overlayNode.classList.add("no-select");
    overlayNode.addEventListener("click", function () {
        if (screenfull.isEnabled) {
            screenfull.toggle(sceneNode);
            G.resize();
        } else {
            console.log("No fullscreen mode available :(");
        }
    });
}

let G = null;
let filterOverlay = null;
let infoOverlay = null;

// Only execute, if corresponding dom is present
if (document.getElementById("3d-graph") !== null) {
    G = new Graph(Config.SPACE, loadComponents);
    filterOverlay = new FilterOverlay(G, "node");
    infoOverlay = new NodeInfoOverlay(G);
    G.infoOverlay = infoOverlay;
}
